## org.apache.lucene.index
Class IndexWriter

    java.lang.Object
      org.apache.lucene.index.IndexWriter

    public class IndexWriter

extends java.lang.Object

An `IndexWriter` creates and maintains an index.

The `create` argument to the `constructor` determines whether a new index is created, or whether an existing index is opened. Note that you can open an index with `create=true` even while readers are using the index. The old readers will continue to search the "point in time" snapshot they had opened, and won't see the newly created index until they re-open. There are also `constructors` with no `create` argument which will create a new index if there is not already an index at the provided path and otherwise open the existing index.

In either case, documents are added with `addDocument` and removed with `deleteDocuments(Term)` or `deleteDocuments(Query)`. A document can be updated with `updateDocument` (which just deletes and then adds the entire document). When finished adding, deleting and updating documents, `close` should be called.

These changes are buffered in memory and periodically flushed to the `Directory` (during the above method calls). A flush is triggered when there are enough buffered deletes (see `setMaxBufferedDeleteTerms(int)`) or enough added documents since the last flush, whichever is sooner. For the added documents, flushing is triggered either by RAM usage of the documents (see `setRAMBufferSizeMB(double)`) or the number of added documents. The default is to flush when RAM usage hits 16 MB. For best indexing speed you should flush by RAM usage with a large RAM buffer. Note that flushing just moves the internal buffered state in IndexWriter into the index, but these changes are not visible to IndexReader until either `commit()` or `close()` is called. A flush may also trigger one or more segment merges which by default run with a background thread so as not to block the addDocument calls (see below for changing the `MergeScheduler`).

The optional `autoCommit` argument to the `constructors` controls visibility of the changes to `IndexReader` instances reading the same index. When this is `false`, changes are not visible until `close()` or `commit()` is called. Note that changes will still be flushed to the `Directory` as new files, but are not committed (no new `segments_N` file is written referencing the new files, nor are the files sync'd to stable storage) until `close()` or `commit()` is called. If something goes terribly wrong (for example the JVM crashes), then the index will reflect none of the changes made since the last commit, or the starting state if commit was not called. You can also call `rollback()`, which closes the writer without committing any changes, and removes any index files that had been flushed but are now unreferenced. This mode is useful for preventing readers from refreshing at a bad time (for example after you've done all your deletes but before you've done your adds). It can also be used to implement simple single-writer transactional semantics ("all or none"). You can do a two-phase commit by calling `prepareCommit()` followed by `commit()`. This is necessary when Lucene is working with an external resource (for example, a database) and both must either commit or rollback the transaction.

When `autoCommit` is `true` then the writer will periodically commit on its own. [Deprecated: Note that in 3.0, IndexWriter will no longer accept autoCommit=true (it will be hardwired to false). You can always call `commit()` yourself when needed]. There is no guarantee when exactly an auto commit will occur (it used to be after every flush, but it is now after every completed merge, as of 2.4). If you want to force a commit, call `commit()`, or, close the writer. Once a commit has finished, newly opened `IndexReader` instances will see the changes to the index as of that commit. When running in this mode, be careful not to refresh your readers while optimize or segment merges are taking place as this can tie up substantial disk space.

Regardless of `autoCommit`, an `IndexReader` or `IndexSearcher` will only see the index as of the "point in time" that it was opened. Any changes committed to the index after the reader was opened are not visible until the reader is re-opened.

If an index will not have more documents added for a while and optimal search performance is desired, then either the full `optimize` method or partial `optimize(int)` method should be called before the index is closed.

Opening an `IndexWriter` creates a lock file for the directory in use. Trying to open another `IndexWriter` on the same directory will lead to a `LockObtainFailedException`. The `LockObtainFailedException` is also thrown if an IndexReader on the same directory is used to delete documents from the index.

Expert: `IndexWriter` allows an optional `IndexDeletionPolicy` implementation to be specified. You can use this to control when prior commits are deleted from the index. The default policy is `KeepOnlyLastCommitDeletionPolicy` which removes all prior commits as soon as a new commit is done (this matches behavior before 2.2). Creating your own policy can allow you to explicitly keep previous "point in time" commits alive in the index for some time, to allow readers to refresh to the new commit without having the old commit deleted out from under them. This is necessary on filesystems like NFS that do not support "delete on last close" semantics, which Lucene's "point in time" search normally relies on.

Expert: `IndexWriter` allows you to separately change the `MergePolicy` and the `MergeScheduler`. The `MergePolicy` is invoked whenever there are changes to the segments in the index. Its role is to select which merges to do, if any, and return a `MergePolicy.MergeSpecification` describing the merges. It also selects merges to do for optimize(). (The default is `LogByteSizeMergePolicy`. Then, the `MergeScheduler` is invoked with the requested merges and it decides when and how to run the merges. The default is `ConcurrentMergeScheduler`.

NOTE: if you hit an OutOfMemoryError then IndexWriter will quietly record this fact and block all future segment commits. This is a defensive measure in case any internal state (buffered documents and deletions) were corrupted. Any subsequent calls to `commit()` will throw an IllegalStateException. The only course of action is to call `close()`, which internally will call `rollback()`, to undo any changes to the index since the last commit. If you opened the writer with autoCommit false you can also just call `rollback()` directly.

NOTE: `IndexWriter` instances are completely thread safe, meaning multiple threads can call any of its methods, concurrently. If your application requires external synchronization, you should not synchronize on the `IndexWriter` instance as this may cause deadlock; use your own (non-Lucene) objects instead.

Nested Class Summary
`static class` `IndexWriter.IndexReaderWarmer` If `getReader()` has been called (ie, this writer is in near real-time mode), then after a merge completes, this class can be invoked to warm the reader on the newly merged segment, before the merge commits.
`static class` `IndexWriter.MaxFieldLength` Specifies maximum field length (in number of tokens/terms) in `IndexWriter` constructors.

Field Summary
`static int` `DEFAULT_MAX_BUFFERED_DELETE_TERMS` Disabled by default (because IndexWriter flushes by RAM usage by default).
`static int` `DEFAULT_MAX_BUFFERED_DOCS` Disabled by default (because IndexWriter flushes by RAM usage by default).
`static int` `DEFAULT_MAX_FIELD_LENGTH` Default value is 10,000.
`static int` `DEFAULT_MAX_MERGE_DOCS` Deprecated.
`static double` `DEFAULT_MAX_SYNC_PAUSE_SECONDS` Default for `getMaxSyncPauseSeconds()`.
`static int` `DEFAULT_MERGE_FACTOR` Deprecated.
`static double` `DEFAULT_RAM_BUFFER_SIZE_MB` Default value is 16 MB (which means flush when buffered docs consume 16 MB RAM).
`static int` `DEFAULT_TERM_INDEX_INTERVAL` Default value is 128.
`static int` `DISABLE_AUTO_FLUSH` Value to denote a flush trigger is disabled
`static int` `MAX_TERM_LENGTH` Absolute hard maximum length for a term.
`static java.lang.String` `WRITE_LOCK_NAME` Name of the write lock in the index.
`static long` `WRITE_LOCK_TIMEOUT` Default value for the write lock timeout (1,000).

Constructor Summary
`IndexWriter(Directory d, Analyzer a)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(Directory d, Analyzer a, boolean create)` Deprecated. This constructor will be removed in the 3.0 release, and call `commit()` when needed. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead.
`IndexWriter(Directory d, Analyzer a, boolean create, IndexDeletionPolicy deletionPolicy, IndexWriter.MaxFieldLength mfl)` Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`.
`IndexWriter(Directory d, Analyzer a, boolean create, IndexWriter.MaxFieldLength mfl)` Constructs an IndexWriter for the index in `d`.
`IndexWriter(Directory d, Analyzer a, IndexDeletionPolicy deletionPolicy, IndexWriter.MaxFieldLength mfl)` Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`, first creating it if it does not already exist.
`IndexWriter(Directory d, Analyzer a, IndexDeletionPolicy deletionPolicy, IndexWriter.MaxFieldLength mfl, IndexCommit commit)` Expert: constructs an IndexWriter on specific commit point, with a custom `IndexDeletionPolicy`, for the index in `d`.
`IndexWriter(Directory d, Analyzer a, IndexWriter.MaxFieldLength mfl)` Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a, boolean create)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a, boolean create, IndexDeletionPolicy deletionPolicy)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,IndexDeletionPolicy,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a, IndexDeletionPolicy deletionPolicy)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,IndexDeletionPolicy,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(java.io.File path, Analyzer a)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(java.io.File path, Analyzer a, boolean create)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(java.io.File path, Analyzer a, boolean create, IndexWriter.MaxFieldLength mfl)` Deprecated. Use `IndexWriter(Directory, Analyzer, boolean, MaxFieldLength)`
`IndexWriter(java.io.File path, Analyzer a, IndexWriter.MaxFieldLength mfl)` Deprecated. Use `IndexWriter(Directory, Analyzer, MaxFieldLength)`
`IndexWriter(java.lang.String path, Analyzer a)` Deprecated. This constructor will be removed in the 3.0 release, and call `commit()` when needed. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead.
`IndexWriter(java.lang.String path, Analyzer a, boolean create)` Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead, and call `commit()` when needed.
`IndexWriter(java.lang.String path, Analyzer a, boolean create, IndexWriter.MaxFieldLength mfl)` Deprecated. Use `IndexWriter(Directory, Analyzer, boolean, MaxFieldLength)`
`IndexWriter(java.lang.String path, Analyzer a, IndexWriter.MaxFieldLength mfl)` Deprecated. Use `IndexWriter(Directory, Analyzer, MaxFieldLength)`

Method Summary
`void` `abort()` Deprecated. Please use `rollback()` instead.
`void` `addDocument(Document doc)` Adds a document to this index.
`void` `addDocument(Document doc, Analyzer analyzer)` Adds a document to this index, using the provided analyzer instead of the value of `getAnalyzer()`.
`void` `addIndexes(Directory[] dirs)` Deprecated. Use `addIndexesNoOptimize(org.apache.lucene.store.Directory[])` instead, then separately call `optimize()` afterwards if you need to.
`void` `addIndexes(IndexReader[] readers)` Merges the provided indexes into this index.
`void` `addIndexesNoOptimize(Directory[] dirs)` Merges all segments from an array of indexes into this index.
`void` `close()` Commits all changes to an index and closes all associated files.
`void` `close(boolean waitForMerges)` Closes the index with or without waiting for currently running merges to finish.
`void` `commit()` Commits all pending changes (added & deleted documents, optimizations, segment merges, added indexes, etc.) to the index, and syncs all referenced index files, such that a reader will see the changes and the index updates will survive an OS or machine crash or power loss.
`void` `commit(java.util.Map commitUserData)` Commits all changes to the index, specifying a commitUserData Map (String -> String).
`void` `deleteAll()` Delete all documents in the index.
`void` `deleteDocuments(Query query)` Deletes the document(s) matching the provided query.
`void` `deleteDocuments(Query[] queries)` Deletes the document(s) matching any of the provided queries.
`void` `deleteDocuments(Term term)` Deletes the document(s) containing `term`.
`void` `deleteDocuments(Term[] terms)` Deletes the document(s) containing any of the terms.
`protected void` `doAfterFlush()` A hook for extending classes to execute operations after pending added and deleted documents have been flushed to the Directory but before the change is committed (new segments_N file written).
`protected void` `doBeforeFlush()` A hook for extending classes to execute operations before pending added and deleted documents are flushed to the Directory.
`int` `docCount()` Deprecated. Please use `maxDoc()` (same as this method) or `numDocs()` (also takes deletions into account), instead.
`protected void` `ensureOpen()`
`protected void` `ensureOpen(boolean includePendingClose)` Used internally to throw an `AlreadyClosedException` if this IndexWriter has been closed.
`void` `expungeDeletes()` Expunges all deletes from the index.
`void` `expungeDeletes(boolean doWait)` Just like `expungeDeletes()`, except you can specify whether the call should block until the operation completes.
`void` `flush()` Deprecated. please call `commit()`) instead
`protected void` `flush(boolean triggerMerge, boolean flushDocStores, boolean flushDeletes)` Flush all in-memory buffered udpates (adds and deletes) to the Directory.
`Analyzer` `getAnalyzer()` Returns the analyzer used by this index.
`static java.io.PrintStream` `getDefaultInfoStream()` Returns the current default infoStream for newly instantiated IndexWriters.
`static long` `getDefaultWriteLockTimeout()` Returns default write lock timeout for newly instantiated IndexWriters.
`Directory` `getDirectory()` Returns the Directory used by this index.
`java.io.PrintStream` `getInfoStream()` Returns the current infoStream in use by this writer.
`int` `getMaxBufferedDeleteTerms()` Returns the number of buffered deleted terms that will trigger a flush if enabled.
`int` `getMaxBufferedDocs()` Returns the number of buffered added documents that will trigger a flush if enabled.
`int` `getMaxFieldLength()` Returns the maximum number of terms that will be indexed for a single field in a document.
`int` `getMaxMergeDocs()` Returns the largest segment (measured by document count) that may be merged with other segments.
`double` `getMaxSyncPauseSeconds()` Deprecated. This will be removed in 3.0, when autoCommit=true is removed from IndexWriter.
`IndexWriter.IndexReaderWarmer` `getMergedSegmentWarmer()` Returns the current merged segment warmer.
`int` `getMergeFactor()` Returns the number of segments that are merged at once and also controls the total number of segments allowed to accumulate in the index.
`MergePolicy` `getMergePolicy()` Expert: returns the current MergePolicy in use by this writer.
`MergeScheduler` `getMergeScheduler()` Expert: returns the current MergePolicy in use by this writer.
`double` `getRAMBufferSizeMB()` Returns the value set by `setRAMBufferSizeMB(double)` if enabled.
`IndexReader` `getReader()` Expert: returns a readonly reader, covering all committed as well as un-committed changes to the index.
`IndexReader` `getReader(int termInfosIndexDivisor)` Expert: like `getReader()`, except you can specify which termInfosIndexDivisor should be used for any newly opened readers.
`int` `getReaderTermsIndexDivisor()`
`Similarity` `getSimilarity()` Expert: Return the Similarity implementation used by this IndexWriter.
`int` `getTermIndexInterval()` Expert: Return the interval between indexed terms.
`boolean` `getUseCompoundFile()` Get the current setting of whether newly flushed segments will use the compound file format.
`long` `getWriteLockTimeout()` Returns allowed timeout when acquiring the write lock.
`boolean` `hasDeletions()`
`static boolean` `isLocked(Directory directory)` Returns `true` iff the index in the named directory is currently locked.
`static boolean` `isLocked(java.lang.String directory)` Deprecated. Use `isLocked(Directory)`
`int` `maxDoc()` Returns total number of docs in this index, including docs not yet flushed (still in the RAM buffer), not counting deletions.
`void` `maybeMerge()` Expert: asks the mergePolicy whether any merges are necessary now and if so, runs the requested merges and then iterate (test again if merges are needed) until no more merges are returned by the mergePolicy.
`void` `message(java.lang.String message)` Prints a message to the infoStream (if non-null), prefixed with the identifying information for this writer and the thread that's calling it.
`int` `numDeletedDocs(SegmentInfo info)` Obtain the number of deleted docs for a pooled reader.
`int` `numDocs()` Returns total number of docs in this index, including docs not yet flushed (still in the RAM buffer), and including deletions.
`int` `numRamDocs()` Expert: Return the number of documents currently buffered in RAM.
`void` `optimize()` Requests an "optimize" operation on an index, priming the index for the fastest available search.
`void` `optimize(boolean doWait)` Just like `optimize()`, except you can specify whether the call should block until the optimize completes.
`void` `optimize(int maxNumSegments)` Optimize the index down to <= maxNumSegments.
`void` `optimize(int maxNumSegments, boolean doWait)` Just like `optimize(int)`, except you can specify whether the call should block until the optimize completes.
`void` `prepareCommit()` Expert: prepare for commit.
`void` `prepareCommit(java.util.Map commitUserData)` Expert: prepare for commit, specifying commitUserData Map (String -> String).
`long` `ramSizeInBytes()` Expert: Return the total size of all index files currently cached in memory.
`void` `rollback()` Close the `IndexWriter` without committing any changes that have occurred since the last commit (or since it was opened, if commit hasn't been called).
`java.lang.String` `segString()`
`void` `setAllowMinus1Position()` Deprecated: emulates IndexWriter's buggy behavior when first token(s) have positionIncrement==0 (ie, prior to fixing LUCENE-1542)
`static void` `setDefaultInfoStream(java.io.PrintStream infoStream)` If non-null, this will be the default infoStream used by a newly instantiated IndexWriter.
`static void` `setDefaultWriteLockTimeout(long writeLockTimeout)` Sets the default (for any instance of IndexWriter) maximum time to wait for a write lock (in milliseconds).
`void` `setInfoStream(java.io.PrintStream infoStream)` If non-null, information about merges, deletes and a message when maxFieldLength is reached will be printed to this.
`void` `setMaxBufferedDeleteTerms(int maxBufferedDeleteTerms)` Determines the minimal number of delete terms required before the buffered in-memory delete terms are applied and flushed.
`void` `setMaxBufferedDocs(int maxBufferedDocs)` Determines the minimal number of documents required before the buffered in-memory documents are flushed as a new Segment.
`void` `setMaxFieldLength(int maxFieldLength)` The maximum number of terms that will be indexed for a single field in a document.
`void` `setMaxMergeDocs(int maxMergeDocs)` Determines the largest segment (measured by document count) that may be merged with other segments.
`void` `setMaxSyncPauseSeconds(double seconds)` Deprecated. This will be removed in 3.0, when autoCommit=true is removed from IndexWriter.
`void` `setMergedSegmentWarmer(IndexWriter.IndexReaderWarmer warmer)` Set the merged segment warmer.
`void` `setMergeFactor(int mergeFactor)` Determines how often segment indices are merged by addDocument().
`void` `setMergePolicy(MergePolicy mp)` Expert: set the merge policy used by this writer.
`void` `setMergeScheduler(MergeScheduler mergeScheduler)` Expert: set the merge scheduler used by this writer.
`void` `setRAMBufferSizeMB(double mb)` Determines the amount of RAM that may be used for buffering added documents and deletions before they are flushed to the Directory.
`void` `setReaderTermsIndexDivisor(int divisor)` Sets the termsIndexDivisor passed to any readers that IndexWriter opens, for example when applying deletes or creating a near-real-time reader in `getReader()`.
`void` `setSimilarity(Similarity similarity)` Expert: Set the Similarity implementation used by this IndexWriter.
`void` `setTermIndexInterval(int interval)` Expert: Set the interval between indexed terms.
`void` `setUseCompoundFile(boolean value)` Setting to turn on usage of a compound file.
`void` `setWriteLockTimeout(long writeLockTimeout)` Sets the maximum time to wait for a write lock (in milliseconds) for this instance of IndexWriter.
`static void` `unlock(Directory directory)` Forcibly unlocks the index in the named directory.
`void` `updateDocument(Term term, Document doc)` Updates a document by first deleting the document(s) containing `term` and then adding the new document.
`void` `updateDocument(Term term, Document doc, Analyzer analyzer)` Updates a document by first deleting the document(s) containing `term` and then adding the new document.
`boolean` `verbose()` Returns true if verbosing is enabled (i.e., infoStream != null).
`void` `waitForMerges()` Wait for any currently outstanding merges to finish.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### WRITE_LOCK_TIMEOUT

    public static long WRITE_LOCK_TIMEOUT

  Default value for the write lock timeout (1,000).

  See Also:
    `setDefaultWriteLockTimeout(long)`

### WRITE_LOCK_NAME

    public static final java.lang.String WRITE_LOCK_NAME

  Name of the write lock in the index.

  See Also:
    Constant Field Values

### DEFAULT_MERGE_FACTOR

    public static final int DEFAULT_MERGE_FACTOR

  Deprecated.
  See Also:
    `LogMergePolicy.DEFAULT_MERGE_FACTOR`, Constant Field Values

### DISABLE_AUTO_FLUSH

    public static final int DISABLE_AUTO_FLUSH

  Value to denote a flush trigger is disabled

  See Also:
    Constant Field Values

### DEFAULT_MAX_BUFFERED_DOCS

    public static final int DEFAULT_MAX_BUFFERED_DOCS

  Disabled by default (because IndexWriter flushes by RAM usage by default). Change using `setMaxBufferedDocs(int)`.

  See Also:
    Constant Field Values

### DEFAULT_RAM_BUFFER_SIZE_MB

    public static final double DEFAULT_RAM_BUFFER_SIZE_MB

  Default value is 16 MB (which means flush when buffered docs consume 16 MB RAM). Change using `setRAMBufferSizeMB(double)`.

  See Also:
    Constant Field Values

### DEFAULT_MAX_BUFFERED_DELETE_TERMS

    public static final int DEFAULT_MAX_BUFFERED_DELETE_TERMS

  Disabled by default (because IndexWriter flushes by RAM usage by default). Change using `setMaxBufferedDeleteTerms(int)`.

  See Also:
    Constant Field Values

### DEFAULT_MAX_MERGE_DOCS

    public static final int DEFAULT_MAX_MERGE_DOCS

  Deprecated.
  See Also:
    `LogMergePolicy.DEFAULT_MAX_MERGE_DOCS`, Constant Field Values

### DEFAULT_MAX_FIELD_LENGTH

    public static final int DEFAULT_MAX_FIELD_LENGTH

  Default value is 10,000. Change using `setMaxFieldLength(int)`.

  See Also:
    Constant Field Values

### DEFAULT_TERM_INDEX_INTERVAL

    public static final int DEFAULT_TERM_INDEX_INTERVAL

  Default value is 128. Change using `setTermIndexInterval(int)`.

  See Also:
    Constant Field Values

### MAX_TERM_LENGTH

    public static final int MAX_TERM_LENGTH

  Absolute hard maximum length for a term. If a term arrives from the analyzer longer than this length, it is skipped and a message is printed to infoStream, if set (see `setInfoStream(java.io.PrintStream)`).

  See Also:
    Constant Field Values

### DEFAULT_MAX_SYNC_PAUSE_SECONDS

    public static final double DEFAULT_MAX_SYNC_PAUSE_SECONDS

  Default for `getMaxSyncPauseSeconds()`. On Windows this defaults to 10.0 seconds; elsewhere it's 0.

Constructor Detail

### IndexWriter

    public IndexWriter(java.lang.String path,
                       Analyzer a,
                       boolean create,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. Use `IndexWriter(Directory, Analyzer, boolean, MaxFieldLength)`

  Constructs an IndexWriter for the index in `path`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `path`, replacing the index already there, if any.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
    `mfl` - Maximum field length in number of tokens/terms: LIMITED, UNLIMITED, or user-specified via the MaxFieldLength constructor.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(java.lang.String path,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead, and call `commit()` when needed.

  Constructs an IndexWriter for the index in `path`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `path`, replacing the index already there, if any.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(java.io.File path,
                       Analyzer a,
                       boolean create,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. Use `IndexWriter(Directory, Analyzer, boolean, MaxFieldLength)`

  Constructs an IndexWriter for the index in `path`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `path`, replacing the index already there, if any.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
    `mfl` - Maximum field length in number of terms/tokens: LIMITED, UNLIMITED, or user-specified via the MaxFieldLength constructor.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(java.io.File path,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead, and call `commit()` when needed.

  Constructs an IndexWriter for the index in `path`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `path`, replacing the index already there, if any.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a,
                       boolean create,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Constructs an IndexWriter for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
    `mfl` - Maximum field length in number of terms/tokens: LIMITED, UNLIMITED, or user-specified via the MaxFieldLength constructor.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release, and call `commit()` when needed. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead.

  Constructs an IndexWriter for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(java.lang.String path,
                       Analyzer a,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. Use `IndexWriter(Directory, Analyzer, MaxFieldLength)`

  Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist. Text will be analyzed with `a`.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `mfl` - Maximum field length in number of terms/tokens: LIMITED, UNLIMITED, or user-specified via the MaxFieldLength constructor.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(java.lang.String path,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release, and call `commit()` when needed. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead.

  Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(java.io.File path,
                       Analyzer a,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. Use `IndexWriter(Directory, Analyzer, MaxFieldLength)`

  Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist. Text will be analyzed with `a`.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `mfl` - Maximum field length in number of terms/tokens: LIMITED, UNLIMITED, or user-specified via the MaxFieldLength constructor.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(java.io.File path,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead, and call `commit()` when needed.

  Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
    `mfl` - Maximum field length in number of terms/tokens: LIMITED, UNLIMITED, or user-specified via the MaxFieldLength constructor.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead, and call `commit()` when needed.

  Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,MaxFieldLength)` instead, and call `commit()` when needed.

  Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,MaxFieldLength)` instead, and call `commit()` when needed.

  Constructs an IndexWriter for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a,
                       IndexDeletionPolicy deletionPolicy,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
    `deletionPolicy` - see above
    `mfl` - whether or not to limit field lengths
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a,
                       IndexDeletionPolicy deletionPolicy)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,IndexDeletionPolicy,MaxFieldLength)` instead, and call `commit()` when needed.

  Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
    `deletionPolicy` - see above
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a,
                       boolean create,
                       IndexDeletionPolicy deletionPolicy,
                       IndexWriter.MaxFieldLength mfl)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
    `deletionPolicy` - see above
    `mfl` - `IndexWriter.MaxFieldLength`, whether or not to limit field lengths. Value is in number of terms/tokens
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a,
                       boolean create,
                       IndexDeletionPolicy deletionPolicy)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Deprecated. This constructor will be removed in the 3.0 release. Use `IndexWriter(Directory,Analyzer,boolean,IndexDeletionPolicy,MaxFieldLength)` instead, and call `commit()` when needed.

  Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
    `deletionPolicy` - see above
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a,
                       IndexDeletionPolicy deletionPolicy,
                       IndexWriter.MaxFieldLength mfl,
                       IndexCommit commit)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       java.io.IOException

  Expert: constructs an IndexWriter on specific commit point, with a custom `IndexDeletionPolicy`, for the index in `d`. Text will be analyzed with `a`.

  This is only meaningful if you've used a `IndexDeletionPolicy` in that past that keeps more than just the last commit.

  This operation is similar to `rollback()`, except that method can only rollback what's been done with the current instance of IndexWriter since its last commit, whereas this method can rollback to an arbitrary commit point from the past, assuming the `IndexDeletionPolicy` has preserved past commits.

  NOTE: autoCommit (see above) is set to false with this constructor.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
    `deletionPolicy` - see above
    `mfl` - whether or not to limit field lengths, value is in number of terms/tokens. See `IndexWriter.MaxFieldLength`.
    `commit` - which commit to open
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `java.io.IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

Method Detail

### getReader

    public IndexReader getReader()
                          throws java.io.IOException

  Expert: returns a readonly reader, covering all committed as well as un-committed changes to the index. This provides "near real-time" searching, in that changes made during an IndexWriter session can be quickly made available for searching without closing the writer nor calling `commit(long)`.

  Note that this is functionally equivalent to calling {#commit} and then using `IndexReader.open(java.lang.String)` to open a new reader. But the turarnound time of this method should be faster since it avoids the potentially costly `commit(long)`.

  You must close the `IndexReader` returned by this method once you are done using it.

  It's near real-time because there is no hard guarantee on how quickly you can get a new reader after making changes with IndexWriter. You'll have to experiment in your situation to determine if it's fast enough. As this is a new and experimental feature, please report back on your findings so we can learn, improve and iterate.

  The resulting reader supports `IndexReader.reopen()`, but that call will simply forward back to this method (though this may change in the future).

  The very first time this method is called, this writer instance will make every effort to pool the readers that it opens for doing merges, applying deletes, etc. This means additional resources (RAM, file descriptors, CPU time) will be consumed.

  For lower latency on reopening a reader, you should call `setMergedSegmentWarmer(org.apache.lucene.index.IndexWriter.IndexReaderWarmer)` to pre-warm a newly merged segment before it's committed to the index. This is important for minimizing index-to-search delay after a large merge.

  If an addIndexes* call is running in another thread, then this reader will only search those segments from the foreign index that have been successfully copied over, so far

  .

  NOTE: Once the writer is closed, any outstanding readers may continue to be used. However, if you attempt to reopen any of those readers, you'll hit an `AlreadyClosedException`.

  NOTE: This API is experimental and might change in incompatible ways in the next release.

  Returns:
    IndexReader that covers entire index plus all changes made so far by this IndexWriter instance
  Throws:
    `java.io.IOException`

### getReader

    public IndexReader getReader(int termInfosIndexDivisor)
                          throws java.io.IOException

  Expert: like `getReader()`, except you can specify which termInfosIndexDivisor should be used for any newly opened readers.

  Parameters:
    `termInfosIndexDivisor` - Subsamples which indexed terms are loaded into RAM. This has the same effect as `setTermIndexInterval(int)` except that setting must be done at indexing time while this setting can be set per reader. When set to N, then one in every N*termIndexInterval terms in the index is loaded into memory. By setting this to a value > 1 you can reduce memory usage, at the expense of higher latency when loading a TermInfo. The default value is 1. Set this to -1 to skip loading the terms index entirely.
  Throws:
    `java.io.IOException`

### numDeletedDocs

    public int numDeletedDocs(SegmentInfo info)
                       throws java.io.IOException

  Obtain the number of deleted docs for a pooled reader. If the reader isn't being pooled, the segmentInfo's delCount is returned.

  Throws:
    `java.io.IOException`

### ensureOpen

    protected final void ensureOpen(boolean includePendingClose)
                             throws AlreadyClosedException

  Used internally to throw an `AlreadyClosedException` if this IndexWriter has been closed.

  Throws:
    `AlreadyClosedException` - if this IndexWriter is

### ensureOpen

    protected final void ensureOpen()
                             throws AlreadyClosedException

  Throws:
    `AlreadyClosedException`

### message

    public void message(java.lang.String message)

  Prints a message to the infoStream (if non-null), prefixed with the identifying information for this writer and the thread that's calling it.

### getUseCompoundFile

    public boolean getUseCompoundFile()

  Get the current setting of whether newly flushed segments will use the compound file format. Note that this just returns the value previously set with setUseCompoundFile(boolean), or the default value (true). You cannot use this to query the status of previously flushed segments.

  Note that this method is a convenience method: it just calls mergePolicy.getUseCompoundFile as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  See Also:
    `setUseCompoundFile(boolean)`

### setUseCompoundFile

    public void setUseCompoundFile(boolean value)

  Setting to turn on usage of a compound file. When on, multiple files for each segment are merged into a single file when a new segment is flushed.

  Note that this method is a convenience method: it just calls mergePolicy.setUseCompoundFile as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

### setSimilarity

    public void setSimilarity(Similarity similarity)

  Expert: Set the Similarity implementation used by this IndexWriter.

  See Also:
    `Similarity.setDefault(Similarity)`

### getSimilarity

    public Similarity getSimilarity()

  Expert: Return the Similarity implementation used by this IndexWriter.

  This defaults to the current value of `Similarity.getDefault()`.

### setTermIndexInterval

    public void setTermIndexInterval(int interval)

  Expert: Set the interval between indexed terms. Large values cause less memory to be used by IndexReader, but slow random-access to terms. Small values cause more memory to be used by an IndexReader, and speed random-access to terms. This parameter determines the amount of computation required per query term, regardless of the number of documents that contain that term. In particular, it is the maximum number of other terms that must be scanned before a term is located and its frequency and position information may be processed. In a large index with user-entered query terms, query processing time is likely to be dominated not by term lookup but rather by the processing of frequency and positional data. In a small index or when many uncommon query terms are generated (e.g., by wildcard queries) term lookup may become a dominant cost. In particular, `numUniqueTerms/interval` terms are read into memory by an IndexReader, and, on average, `interval/2` terms must be scanned for each random term access.

  See Also:
    `DEFAULT_TERM_INDEX_INTERVAL`

### getTermIndexInterval

    public int getTermIndexInterval()

  Expert: Return the interval between indexed terms.

  See Also:
    `setTermIndexInterval(int)`

### setMergePolicy

    public void setMergePolicy(MergePolicy mp)

  Expert: set the merge policy used by this writer.

### getMergePolicy

    public MergePolicy getMergePolicy()

  Expert: returns the current MergePolicy in use by this writer.

  See Also:
    `setMergePolicy(org.apache.lucene.index.MergePolicy)`

### setMergeScheduler

    public void setMergeScheduler(MergeScheduler mergeScheduler)
                           throws CorruptIndexException,
                                  java.io.IOException

  Expert: set the merge scheduler used by this writer.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### getMergeScheduler

    public MergeScheduler getMergeScheduler()

  Expert: returns the current MergePolicy in use by this writer.

  See Also:
    `setMergePolicy(org.apache.lucene.index.MergePolicy)`

### setMaxMergeDocs

    public void setMaxMergeDocs(int maxMergeDocs)

  Determines the largest segment (measured by document count) that may be merged with other segments. Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches.

  The default value is `Integer.MAX_VALUE`.

  Note that this method is a convenience method: it just calls mergePolicy.setMaxMergeDocs as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  The default merge policy (`LogByteSizeMergePolicy`) also allows you to set this limit by net size (in MB) of the segment, using `LogByteSizeMergePolicy.setMaxMergeMB(double)`.

### getMaxMergeDocs

    public int getMaxMergeDocs()

  Returns the largest segment (measured by document count) that may be merged with other segments.

  Note that this method is a convenience method: it just calls mergePolicy.getMaxMergeDocs as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  See Also:
    `setMaxMergeDocs(int)`

### setMaxFieldLength

    public void setMaxFieldLength(int maxFieldLength)

  The maximum number of terms that will be indexed for a single field in a document. This limits the amount of memory required for indexing, so that collections with very large files will not crash the indexing process by running out of memory. This setting refers to the number of running terms, not to the number of different terms.

  Note: this silently truncates large documents, excluding from the index all terms that occur further in the document. If you know your source documents are large, be sure to set this value high enough to accomodate the expected size. If you set it to Integer.MAX_VALUE, then the only limit is your memory, but you should anticipate an OutOfMemoryError.

  By default, no more than `DEFAULT_MAX_FIELD_LENGTH` terms will be indexed for a field.

### getMaxFieldLength

    public int getMaxFieldLength()

  Returns the maximum number of terms that will be indexed for a single field in a document.

  See Also:
    `setMaxFieldLength(int)`

### setReaderTermsIndexDivisor

    public void setReaderTermsIndexDivisor(int divisor)

  Sets the termsIndexDivisor passed to any readers that IndexWriter opens, for example when applying deletes or creating a near-real-time reader in `getReader()`. Default value is `IndexReader.DEFAULT_TERMS_INDEX_DIVISOR`.

### getReaderTermsIndexDivisor

    public int getReaderTermsIndexDivisor()

  See Also:
    `setReaderTermsIndexDivisor(int)`

### setMaxBufferedDocs

    public void setMaxBufferedDocs(int maxBufferedDocs)

  Determines the minimal number of documents required before the buffered in-memory documents are flushed as a new Segment. Large values generally gives faster indexing.

  When this is set, the writer will flush every maxBufferedDocs added documents. Pass in `DISABLE_AUTO_FLUSH` to prevent triggering a flush due to number of buffered documents. Note that if flushing by RAM usage is also enabled, then the flush will be triggered by whichever comes first.

  Disabled by default (writer flushes by RAM usage).

  Throws:
    `java.lang.IllegalArgumentException` - if maxBufferedDocs is enabled but smaller than 2, or it disables maxBufferedDocs when ramBufferSize is already disabled
  See Also:
    `setRAMBufferSizeMB(double)`

### getMaxBufferedDocs

    public int getMaxBufferedDocs()

  Returns the number of buffered added documents that will trigger a flush if enabled.

  See Also:
    `setMaxBufferedDocs(int)`

### setRAMBufferSizeMB

    public void setRAMBufferSizeMB(double mb)

  Determines the amount of RAM that may be used for buffering added documents and deletions before they are flushed to the Directory. Generally for faster indexing performance it's best to flush by RAM usage instead of document count and use as large a RAM buffer as you can.

  When this is set, the writer will flush whenever buffered documents and deletions use this much RAM. Pass in `DISABLE_AUTO_FLUSH` to prevent triggering a flush due to RAM usage. Note that if flushing by document count is also enabled, then the flush will be triggered by whichever comes first.

  NOTE: the account of RAM usage for pending deletions is only approximate. Specifically, if you delete by Query, Lucene currently has no way to measure the RAM usage if individual Queries so the accounting will under-estimate and you should compensate by either calling commit() periodically yourself, or by using `setMaxBufferedDeleteTerms(int)` to flush by count instead of RAM usage (each buffered delete Query counts as one).

  NOTE: because IndexWriter uses `int`s when managing its internal storage, the absolute maximum value for this setting is somewhat less than 2048 MB. The precise limit depends on various factors, such as how large your documents are, how many fields have norms, etc., so it's best to set this value comfortably under 2048.

  The default value is `DEFAULT_RAM_BUFFER_SIZE_MB`.

  Throws:
    `java.lang.IllegalArgumentException` - if ramBufferSize is enabled but non-positive, or it disables ramBufferSize when maxBufferedDocs is already disabled

### getRAMBufferSizeMB

    public double getRAMBufferSizeMB()

  Returns the value set by `setRAMBufferSizeMB(double)` if enabled.

### setMaxBufferedDeleteTerms

    public void setMaxBufferedDeleteTerms(int maxBufferedDeleteTerms)

  Determines the minimal number of delete terms required before the buffered in-memory delete terms are applied and flushed. If there are documents buffered in memory at the time, they are merged and a new segment is created.

  Disabled by default (writer flushes by RAM usage).

  Throws:
    `java.lang.IllegalArgumentException` - if maxBufferedDeleteTerms is enabled but smaller than 1
  See Also:
    `setRAMBufferSizeMB(double)`

### getMaxBufferedDeleteTerms

    public int getMaxBufferedDeleteTerms()

  Returns the number of buffered deleted terms that will trigger a flush if enabled.

  See Also:
    `setMaxBufferedDeleteTerms(int)`

### setMergeFactor

    public void setMergeFactor(int mergeFactor)

  Determines how often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained.

  Note that this method is a convenience method: it just calls mergePolicy.setMergeFactor as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  This must never be less than 2. The default value is 10.

### getMergeFactor

    public int getMergeFactor()

  Returns the number of segments that are merged at once and also controls the total number of segments allowed to accumulate in the index.

  Note that this method is a convenience method: it just calls mergePolicy.getMergeFactor as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  See Also:
    `setMergeFactor(int)`

### getMaxSyncPauseSeconds

    public double getMaxSyncPauseSeconds()

  Deprecated. This will be removed in 3.0, when autoCommit=true is removed from IndexWriter.

  Expert: returns max delay inserted before syncing a commit point. On Windows, at least, pausing before syncing can increase net indexing throughput. The delay is variable based on size of the segment's files, and is only inserted when using ConcurrentMergeScheduler for merges.

### setMaxSyncPauseSeconds

    public void setMaxSyncPauseSeconds(double seconds)

  Deprecated. This will be removed in 3.0, when autoCommit=true is removed from IndexWriter.

  Expert: sets the max delay before syncing a commit point.

  See Also:
    `getMaxSyncPauseSeconds()`

### setDefaultInfoStream

    public static void setDefaultInfoStream(java.io.PrintStream infoStream)

  If non-null, this will be the default infoStream used by a newly instantiated IndexWriter.

  See Also:
    `setInfoStream(java.io.PrintStream)`

### getDefaultInfoStream

    public static java.io.PrintStream getDefaultInfoStream()

  Returns the current default infoStream for newly instantiated IndexWriters.

  See Also:
    `setDefaultInfoStream(java.io.PrintStream)`

### setInfoStream

    public void setInfoStream(java.io.PrintStream infoStream)

  If non-null, information about merges, deletes and a message when maxFieldLength is reached will be printed to this.

### getInfoStream

    public java.io.PrintStream getInfoStream()

  Returns the current infoStream in use by this writer.

  See Also:
    `setInfoStream(java.io.PrintStream)`

### verbose

    public boolean verbose()

  Returns true if verbosing is enabled (i.e., infoStream != null).

### setWriteLockTimeout

    public void setWriteLockTimeout(long writeLockTimeout)

  Sets the maximum time to wait for a write lock (in milliseconds) for this instance of IndexWriter. @see

  See Also:
    `to change the default value for all instances of IndexWriter.`

### getWriteLockTimeout

    public long getWriteLockTimeout()

  Returns allowed timeout when acquiring the write lock.

  See Also:
    `setWriteLockTimeout(long)`

### setDefaultWriteLockTimeout

    public static void setDefaultWriteLockTimeout(long writeLockTimeout)

  Sets the default (for any instance of IndexWriter) maximum time to wait for a write lock (in milliseconds).

### getDefaultWriteLockTimeout

    public static long getDefaultWriteLockTimeout()

  Returns default write lock timeout for newly instantiated IndexWriters.

  See Also:
    `setDefaultWriteLockTimeout(long)`

### close

    public void close()
               throws CorruptIndexException,
                      java.io.IOException

  Commits all changes to an index and closes all associated files. Note that this may be a costly operation, so, try to re-use a single writer instead of closing and opening a new one. See `commit()` for caveats about write caching done by some IO devices.

  If an Exception is hit during close, eg due to disk full or some other reason, then both the on-disk index and the internal state of the IndexWriter instance will be consistent. However, the close will not be complete even though part of it (flushing buffered documents) may have succeeded, so the write lock will still be held.

  If you can correct the underlying cause (eg free up some disk space) then you can call close() again. Failing that, if you want to force the write lock to be released (dangerous, because you may then lose buffered docs in the IndexWriter instance) then you can do something like this:

       try {
         writer.close();
       } finally {
         if (IndexWriter.isLocked(directory)) {
           IndexWriter.unlock(directory);
         }
       }

  after which, you must be certain not to use the writer instance anymore.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer, again. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### close

    public void close(boolean waitForMerges)
               throws CorruptIndexException,
                      java.io.IOException

  Closes the index with or without waiting for currently running merges to finish. This is only meaningful when using a MergeScheduler that runs merges in background threads.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer, again. See above for details.

  NOTE: it is dangerous to always call close(false), especially when IndexWriter is not open for very long, because this can result in "merge starvation" whereby long merges will never have a chance to finish. This will cause too many segments in your index over time.

  Parameters:
    `waitForMerges` - if true, this call will block until all merges complete; else, it will ask all running merges to abort, wait until those merges have finished (which should be at most a few seconds), and then return.
  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### getDirectory

    public Directory getDirectory()

  Returns the Directory used by this index.

### getAnalyzer

    public Analyzer getAnalyzer()

  Returns the analyzer used by this index.

### docCount

    public int docCount()

  Deprecated. Please use `maxDoc()` (same as this method) or `numDocs()` (also takes deletions into account), instead.

  Returns the number of documents currently in this index, not counting deletions.

### maxDoc

    public int maxDoc()

  Returns total number of docs in this index, including docs not yet flushed (still in the RAM buffer), not counting deletions.

  See Also:
    `numDocs()`

### numDocs

    public int numDocs()
                throws java.io.IOException

  Returns total number of docs in this index, including docs not yet flushed (still in the RAM buffer), and including deletions. NOTE: buffered deletions are not counted. If you really need these to be counted you should call `commit()` first.

  Throws:
    `java.io.IOException`
  See Also:
    `numDocs()`

### hasDeletions

    public boolean hasDeletions()
                         throws java.io.IOException

  Throws:
    `java.io.IOException`

### addDocument

    public void addDocument(Document doc)
                     throws CorruptIndexException,
                            java.io.IOException

  Adds a document to this index. If the document contains more than `setMaxFieldLength(int)` terms for a given field, the remainder are discarded.

  Note that if an Exception is hit (for example disk full) then the index will be consistent, but this document may not have been added. Furthermore, it's possible the index will have one segment in non-compound format even when using compound files (when a merge has partially succeeded).

  This method periodically flushes pending documents to the Directory (see above), and also periodically triggers segment merges in the index according to the `MergePolicy` in use.

  Merges temporarily consume space in the directory. The amount of space required is up to 1X the size of all segments being merged, when no readers/searchers are open against the index, and up to 2X the size of all segments being merged when readers/searchers are open against the index (see `optimize()` for details). The sequence of primitive merge operations performed is governed by the merge policy.

  Note that each term in the document can be no longer than 16383 characters, otherwise an IllegalArgumentException will be thrown.

  Note that it's possible to create an invalid Unicode string in java if a UTF16 surrogate pair is malformed. In this case, the invalid characters are silently replaced with the Unicode replacement character U+FFFD.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### addDocument

    public void addDocument(Document doc,
                            Analyzer analyzer)
                     throws CorruptIndexException,
                            java.io.IOException

  Adds a document to this index, using the provided analyzer instead of the value of `getAnalyzer()`. If the document contains more than `setMaxFieldLength(int)` terms for a given field, the remainder are discarded.

  See `addDocument(Document)` for details on index and IndexWriter state after an Exception, and flushing/merging temporary free space requirements.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### deleteDocuments

    public void deleteDocuments(Term term)
                         throws CorruptIndexException,
                                java.io.IOException

  Deletes the document(s) containing `term`.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `term` - the term to identify the documents to be deleted
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### deleteDocuments

    public void deleteDocuments(Term[] terms)
                         throws CorruptIndexException,
                                java.io.IOException

  Deletes the document(s) containing any of the terms. All deletes are flushed at the same time.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `terms` - array of terms to identify the documents to be deleted
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### deleteDocuments

    public void deleteDocuments(Query query)
                         throws CorruptIndexException,
                                java.io.IOException

  Deletes the document(s) matching the provided query.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `query` - the query to identify the documents to be deleted
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### deleteDocuments

    public void deleteDocuments(Query[] queries)
                         throws CorruptIndexException,
                                java.io.IOException

  Deletes the document(s) matching any of the provided queries. All deletes are flushed at the same time.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `queries` - array of queries to identify the documents to be deleted
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### updateDocument

    public void updateDocument(Term term,
                               Document doc)
                        throws CorruptIndexException,
                               java.io.IOException

  Updates a document by first deleting the document(s) containing `term` and then adding the new document. The delete and then add are atomic as seen by a reader on the same index (flush may happen only after the add).

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `term` - the term to identify the document(s) to be deleted
    `doc` - the document to be added
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### updateDocument

    public void updateDocument(Term term,
                               Document doc,
                               Analyzer analyzer)
                        throws CorruptIndexException,
                               java.io.IOException

  Updates a document by first deleting the document(s) containing `term` and then adding the new document. The delete and then add are atomic as seen by a reader on the same index (flush may happen only after the add).

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `term` - the term to identify the document(s) to be deleted
    `doc` - the document to be added
    `analyzer` - the analyzer to use when analyzing the document
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### optimize

    public void optimize()
                  throws CorruptIndexException,
                         java.io.IOException

  Requests an "optimize" operation on an index, priming the index for the fastest available search. Traditionally this has meant merging all segments into a single segment as is done in the default merge policy, but individual merge policies may implement optimize in different ways.

  It is recommended that this method be called upon completion of indexing. In environments with frequent updates, optimize is best done during low volume times, if at all.

  See http://www.gossamer-threads.com/lists/lucene/java-dev/47895 for more discussion.

  Note that optimize requires 2X the index size free space in your Directory (3X if you're using compound file format). For example, if your index size is 10 MB then you need 20 MB free for optimize to complete (30 MB if you're using compound fiel format).

  If some but not all readers re-open while an optimize is underway, this will cause > 2X temporary space to be consumed as those new readers will then hold open the partially optimized segments at that time. It is best not to re-open readers while optimize is running.

  The actual temporary usage could be much less than these figures (it depends on many factors).

  In general, once the optimize completes, the total size of the index will be less than the size of the starting index. It could be quite a bit smaller (if there were many pending deletes) or just slightly smaller.

  If an Exception is hit during optimize(), for example due to disk full, the index will not be corrupt and no documents will have been lost. However, it may have been partially optimized (some segments were merged but not all), and it's possible that one of the segments in the index will be in non-compound format even when using compound file format. This will occur when the Exception is hit during conversion of the segment into compound format.

  This call will optimize those segments present in the index when the call started. If other threads are still adding documents and flushing segments, those newly created segments will not be optimized unless you call optimize again.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error
  See Also:
    `LogMergePolicy.findMergesForOptimize(org.apache.lucene.index.SegmentInfos, int, java.util.Set)`

### optimize

    public void optimize(int maxNumSegments)
                  throws CorruptIndexException,
                         java.io.IOException

  Optimize the index down to <= maxNumSegments. If maxNumSegments==1 then this is the same as `optimize()`.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `maxNumSegments` - maximum number of segments left in the index after optimization finishes
  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### optimize

    public void optimize(boolean doWait)
                  throws CorruptIndexException,
                         java.io.IOException

  Just like `optimize()`, except you can specify whether the call should block until the optimize completes. This is only meaningful with a `MergeScheduler` that is able to run merges in background threads.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### optimize

    public void optimize(int maxNumSegments,
                         boolean doWait)
                  throws CorruptIndexException,
                         java.io.IOException

  Just like `optimize(int)`, except you can specify whether the call should block until the optimize completes. This is only meaningful with a `MergeScheduler` that is able to run merges in background threads.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### expungeDeletes

    public void expungeDeletes(boolean doWait)
                        throws CorruptIndexException,
                               java.io.IOException

  Just like `expungeDeletes()`, except you can specify whether the call should block until the operation completes. This is only meaningful with a `MergeScheduler` that is able to run merges in background threads.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### expungeDeletes

    public void expungeDeletes()
                        throws CorruptIndexException,
                               java.io.IOException

  Expunges all deletes from the index. When an index has many document deletions (or updates to existing documents), it's best to either call optimize or expungeDeletes to remove all unused data in the index associated with the deleted documents. To see how many deletions you have pending in your index, call `IndexReader.numDeletedDocs()` This saves disk space and memory usage while searching. expungeDeletes should be somewhat faster than optimize since it does not insist on reducing the index to a single segment (though, this depends on the `MergePolicy`; see `MergePolicy.findMergesToExpungeDeletes(org.apache.lucene.index.SegmentInfos)`.). Note that this call does not first commit any buffered documents, so you must do so yourself if necessary. See also `expungeDeletes(boolean)`

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### maybeMerge

    public final void maybeMerge()
                          throws CorruptIndexException,
                                 java.io.IOException

  Expert: asks the mergePolicy whether any merges are necessary now and if so, runs the requested merges and then iterate (test again if merges are needed) until no more merges are returned by the mergePolicy. Explicit calls to maybeMerge() are usually not necessary. The most common case is when merge policy parameters have changed.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### abort

    public void abort()
               throws java.io.IOException

  Deprecated. Please use `rollback()` instead.

  Throws:
    `java.io.IOException`

### rollback

    public void rollback()
                  throws java.io.IOException

  Close the `IndexWriter` without committing any changes that have occurred since the last commit (or since it was opened, if commit hasn't been called). This removes any temporary files that had been created, after which the state of the index will be the same as it was when commit() was last called or when this writer was first opened. This can only be called when this IndexWriter was opened with `autoCommit=false`. This also clears a previous call to `prepareCommit()`.

  Throws:
    `java.lang.IllegalStateException` - if this is called when the writer was opened with `autoCommit=true`.
    `java.io.IOException` - if there is a low-level IO error

### deleteAll

    public void deleteAll()
                   throws java.io.IOException

  Delete all documents in the index.

  This method will drop all buffered documents and will remove all segments from the index. This change will not be visible until a `commit()` has been called. This method can be rolled back using `rollback()`.

  NOTE: this method is much faster than using deleteDocuments( new MatchAllDocsQuery() ).

  NOTE: this method will forcefully abort all merges in progress. If other threads are running `optimize()` or any of the addIndexes methods, they will receive `MergePolicy.MergeAbortedException`s.

  Throws:
    `java.io.IOException`

### waitForMerges

    public void waitForMerges()

  Wait for any currently outstanding merges to finish.

  It is guaranteed that any merges started prior to calling this method will have completed once this method completes.

### addIndexes

    public void addIndexes(Directory[] dirs)
                    throws CorruptIndexException,
                           java.io.IOException

  Deprecated. Use `addIndexesNoOptimize(org.apache.lucene.store.Directory[])` instead, then separately call `optimize()` afterwards if you need to.

  Merges all segments from an array of indexes into this index.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### addIndexesNoOptimize

    public void addIndexesNoOptimize(Directory[] dirs)
                              throws CorruptIndexException,
                                     java.io.IOException

  Merges all segments from an array of indexes into this index.

  This may be used to parallelize batch indexing. A large document collection can be broken into sub-collections. Each sub-collection can be indexed in parallel, on a different thread, process or machine. The complete index can then be created by merging sub-collection indexes with this method.

  NOTE: the index in each Directory must not be changed (opened by a writer) while this method is running. This method does not acquire a write lock in each input Directory, so it is up to the caller to enforce this.

  NOTE: while this is running, any attempts to add or delete documents (with another thread) will be paused until this method completes.

  This method is transactional in how Exceptions are handled: it does not commit a new segments_N file until all indexes are added. This means if an Exception occurs (for example disk full), then either no indexes will have been added or they all will have been.

  Note that this requires temporary free space in the Directory up to 2X the sum of all input indexes (including the starting index). If readers/searchers are open against the starting index, then temporary free space required will be higher by the size of the starting index (see `optimize()` for details).

  Once this completes, the final size of the index will be less than the sum of all input index sizes (including the starting index). It could be quite a bit smaller (if there were many pending deletes) or just slightly smaller.

  This requires this index not be among those to be added.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### addIndexes

    public void addIndexes(IndexReader[] readers)
                    throws CorruptIndexException,
                           java.io.IOException

  Merges the provided indexes into this index.

  After this completes, the index is optimized.

  The provided IndexReaders are not closed.

  NOTE: while this is running, any attempts to add or delete documents (with another thread) will be paused until this method completes.

  See `addIndexesNoOptimize(Directory[])` for details on transactional semantics, temporary free space required in the Directory, and non-CFS segments on an Exception.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### doAfterFlush

    protected void doAfterFlush()
                         throws java.io.IOException

  A hook for extending classes to execute operations after pending added and deleted documents have been flushed to the Directory but before the change is committed (new segments_N file written).

  Throws:
    `java.io.IOException`

### flush

    public final void flush()
                     throws CorruptIndexException,
                            java.io.IOException

  Deprecated. please call `commit()`) instead

  Flush all in-memory buffered updates (adds and deletes) to the Directory.

  Note: while this will force buffered docs to be pushed into the index, it will not make these docs visible to a reader. Use `commit()` instead

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### doBeforeFlush

    protected void doBeforeFlush()
                          throws java.io.IOException

  A hook for extending classes to execute operations before pending added and deleted documents are flushed to the Directory.

  Throws:
    `java.io.IOException`

### prepareCommit

    public final void prepareCommit()
                             throws CorruptIndexException,
                                    java.io.IOException

  Expert: prepare for commit.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`
  See Also:
    `prepareCommit(Map)`

### prepareCommit

    public final void prepareCommit(java.util.Map commitUserData)
                             throws CorruptIndexException,
                                    java.io.IOException

  Expert: prepare for commit, specifying commitUserData Map (String -> String). This does the first phase of 2-phase commit. You can only call this when autoCommit is false. This method does all steps necessary to commit changes since this writer was opened: flushes pending added and deleted docs, syncs the index files, writes most of next segments_N file. After calling this you must call either `commit()` to finish the commit, or `rollback()` to revert the commit and undo all changes done since the writer was opened.

  You can also just call `commit(Map)` directly without prepareCommit first in which case that method will internally call prepareCommit.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Parameters:
    `commitUserData` - Opaque Map (String->String) that's recorded into the segments file in the index, and retrievable by `IndexReader.getCommitUserData(org.apache.lucene.store.Directory)`. Note that when IndexWriter commits itself, for example if open with autoCommit=true, or, during `close()`, the commitUserData is unchanged (just carried over from the prior commit). If this is null then the previous commitUserData is kept. Also, the commitUserData will only "stick" if there are actually changes in the index to commit. Therefore it's best to use this feature only when autoCommit is false.
  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### commit

    public final void commit()
                      throws CorruptIndexException,
                             java.io.IOException

  Commits all pending changes (added & deleted documents, optimizations, segment merges, added indexes, etc.) to the index, and syncs all referenced index files, such that a reader will see the changes and the index updates will survive an OS or machine crash or power loss. Note that this does not wait for any running background merges to finish. This may be a costly operation, so you should test the cost in your application and do it only when really necessary.

  Note that this operation calls Directory.sync on the index files. That call should not return until the file contents & metadata are on stable storage. For FSDirectory, this calls the OS's fsync. But, beware: some hardware devices may in fact cache writes even during fsync, and return before the bits are actually on stable storage, to give the appearance of faster performance. If you have such a device, and it does not have a battery backup (for example) then on power loss it may still lose data. Lucene cannot guarantee consistency on such devices.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`
  See Also:
    `prepareCommit()`, `commit(Map)`

### commit

    public final void commit(java.util.Map commitUserData)
                      throws CorruptIndexException,
                             java.io.IOException

  Commits all changes to the index, specifying a commitUserData Map (String -> String). This just calls `prepareCommit(Map)` (if you didn't already call it) and then `finishCommit()`.

  NOTE: if this method hits an OutOfMemoryError you should immediately close the writer. See above for details.

  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### flush

    protected final void flush(boolean triggerMerge,
                               boolean flushDocStores,
                               boolean flushDeletes)
                        throws CorruptIndexException,
                               java.io.IOException

  Flush all in-memory buffered udpates (adds and deletes) to the Directory.

  Parameters:
    `triggerMerge` - if true, we may merge segments (if deletes or docs were flushed) if necessary
    `flushDocStores` - if false we are allowed to keep doc stores open to share with the next segment
    `flushDeletes` - whether pending deletes should also be flushed
  Throws:
    `CorruptIndexException`
    `java.io.IOException`

### ramSizeInBytes

    public final long ramSizeInBytes()

  Expert: Return the total size of all index files currently cached in memory. Useful for size management with flushRamDocs()

### numRamDocs

    public final int numRamDocs()

  Expert: Return the number of documents currently buffered in RAM.

### segString

    public java.lang.String segString()

### isLocked

    public static boolean isLocked(Directory directory)
                            throws java.io.IOException

  Returns `true` iff the index in the named directory is currently locked.

  Parameters:
    `directory` - the directory to check for a lock
  Throws:
    `java.io.IOException` - if there is a low-level IO error

### isLocked

    public static boolean isLocked(java.lang.String directory)
                            throws java.io.IOException

  Deprecated. Use `isLocked(Directory)`

  Returns `true` iff the index in the named directory is currently locked.

  Parameters:
    `directory` - the directory to check for a lock
  Throws:
    `java.io.IOException` - if there is a low-level IO error

### unlock

    public static void unlock(Directory directory)
                       throws java.io.IOException

  Forcibly unlocks the index in the named directory.

  Caution: this should only be used by failure recovery code, when it is known that no other process nor thread is in fact currently accessing this index.

  Throws:
    `java.io.IOException`

### setMergedSegmentWarmer

    public void setMergedSegmentWarmer(IndexWriter.IndexReaderWarmer warmer)

  Set the merged segment warmer. See `IndexWriter.IndexReaderWarmer`.

### getMergedSegmentWarmer

    public IndexWriter.IndexReaderWarmer getMergedSegmentWarmer()

  Returns the current merged segment warmer. See `IndexWriter.IndexReaderWarmer`.

### setAllowMinus1Position

    public void setAllowMinus1Position()

  Deprecated: emulates IndexWriter's buggy behavior when first token(s) have positionIncrement==0 (ie, prior to fixing LUCENE-1542)

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.